#include "spawn.h"

#include "..\algorithms.h"

void botInfo::gotHelp(Player *p, Command *c)
{
	// List commands

	if (!*c->final)
	{
		switch (p->access)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
//				sendPrivate(p, "Ext: ");
			}
		case OP_SysOp:
			{	// SysOp-level commands
//				sendPrivate(p, "Ext: ");
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
//				sendPrivate(p, "Ext: ");
			}
		case OP_Moderator:
			{	// Moderator-level commands
//				sendPrivate(p, "Ext: ");
			}
		case OP_Limited:
			{	// Limited-level commands
				sendPrivate(p, "!start  -Starts Object Handling");
				sendPrivate(p, "!stop   -Stops Object Handling");
			}
		case OP_Player:
			{	// Player-level commands
				sendPrivate(p, "!about  -Designers and Bot Info");
				sendPrivate(p, "!status -Bot Status");
			}
		}

		return;
	}

	// Specific command help

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
			if (c->checkParam("owner") || c->checkParam("all"))
			{
//				sendPrivate(p, "Ext: ");
			}
		}
	case OP_SysOp:
		{	// SysOp-level commands
			if (c->checkParam("sop") || c->checkParam("all"))
			{
//				sendPrivate(p, "Ext: ");
			}
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
			if (c->checkParam("smod") || c->checkParam("all"))
			{
//				sendPrivate(p, "Ext: ");
			}
		}
	case OP_Moderator:
		{	// Moderator-level commands
			if (c->checkParam("mod") || c->checkParam("all"))
			{
//				sendPrivate(p, "Ext: ");
			}
		}
	case OP_Limited:
		{	// Limited-level commands
			if (c->checkParam("start"))
			{
				sendPrivate(p, "!start");
				sendPrivate(p, "Starts Object Handling");
			}
			else if (c->checkParam("stop"))
			{
				sendPrivate(p, "!stop");
				sendPrivate(p, "Stops Object Handling");
			}
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotCommand(Player *p, Command *c)
{
	if (!p) return;
	if (!c) return;

	switch (p->access)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
			if (c->check("start"))
			{
				if (Enabled)
				{sendPrivate(p, "Already started");}
				else
				{
					sendPrivate(p, "Started Object Handling");
				}

				Enabled = true;
			}
			else if (c->check("stop"))
			{
				if (!Enabled)
				{sendPrivate(p, "Already stopped");}
				else
				{	
					sendPrivate(p, "Stopped Object Handling");
					BotDisable(); //return all objects to original state
				}
				Enabled = false;
					
			}
		}
	case OP_Player:
		{	// Player-level commands
			if (c->check("about"))
			{
				String s;
				s = "\"TM Baw- LVZ\" 1.4 compiled on ";
				s += __DATE__;
				s += " ";
				s += __TIME__;

				sendPrivate(p, s.msg);

				s = "DLL core version: ";
				s += (int)CORE_MAJOR_VERSION;
				s += ".";
				s += (int)CORE_MINOR_VERSION;

				sendPrivate(p, s.msg);

				sendPrivate(p, "TM Baw v1.2 Originally Made by SOS");
				sendPrivate(p, "Edited for Object Handling by 50% Packetloss(FiftyPacketloss@socal.rr.com)");
				sendPrivate(p, "Endorsements: SSCX Star WarZone(Best Zone Ever) and http://forums.minegoboom.com/");
			}
			else if (c->check("status"))
			{
				_listnode <PlayerTag> *tags= taglist.head;
				unsigned short count=0;

				while(tags)
				{
					if(CheckInside(tags->item)) //count the number of people in obj areas
					{count++;}
					tags = tags->next;
				}

				String s;
				s = "The bot is controlling ";
				s += ObjLocations.total;
				s += " object locations!";
				sendPrivate(p, s.msg);

				s = "There are ";
				s += count;
				s += " people inside object locations!";
				sendPrivate(p, s.msg);

				if (Enabled)
				{sendPrivate(p, "Bot is enabled");}
				else
				{sendPrivate(p, "Bot is disabled");}
			}
		}
	}
}

void botInfo::gotRemoteHelp(char *p, Command *c, Operator_Level l)
{
	// List commands

	if (!*c->final)
	{
		switch (l)
		{
		case OP_Duke:
		case OP_Baron:
		case OP_King:
		case OP_Emperor:
		case OP_RockStar:
		case OP_Q:
		case OP_God:
		case OP_Owner:
			{	// Owner-level commands
			}
		case OP_SysOp:
			{	// SysOp-level commands
			}
		case OP_SuperModerator:
			{	// SuperModerator-level commands
			}
		case OP_Moderator:
			{	// Moderator-level commands
			}
		case OP_Limited:
			{	// Limited-level commands
			}
		case OP_Player:
			{	// Player-level commands
			}
		}

		return;
	}

	// Specific command help

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}

void botInfo::gotRemote(char *p, Command *c, Operator_Level l)
{
	if (!c) return;

	switch (l)
	{
	case OP_Duke:
	case OP_Baron:
	case OP_King:
	case OP_Emperor:
	case OP_RockStar:
	case OP_Q:
	case OP_God:
	case OP_Owner:
		{	// Owner-level commands
		}
	case OP_SysOp:
		{	// SysOp-level commands
		}
	case OP_SuperModerator:
		{	// SuperModerator-level commands
		}
	case OP_Moderator:
		{	// Moderator-level commands
		}
	case OP_Limited:
		{	// Limited-level commands
		}
	case OP_Player:
		{	// Player-level commands
		}
	}
}
